#!/usr/bin/env python3
# -*- coding:utf-8 -*-
# @Author:      thepoy
# @Email:       thepoy@163.com
# @File Name:   package.pyi
# @Created At:  2023-03-20 14:16:58
# @Modified At: 2023-03-20 14:32:40
# @Modified By: thepoy

from typing import BinaryIO
from pathlib import Path
from docx.opc.package import OpcPackage
from docx.parts.image import ImagePart
from docx.image.image import Image
from docx.opc.packuri import PackURI

StrPath = Path | str
ImageDescriptor = StrPath | BinaryIO

class Package(OpcPackage):
    def after_unmarshal(self) -> None: ...
    def get_or_add_image_part(self, image_descriptor: ImageDescriptor) -> ImagePart: ...
    @property
    def image_parts(self) -> ImagePart: ...
    def _gather_image_parts(self) -> None: ...

class ImageParts:
    _image_parts: list[ImagePart]

    def __contains__(self, item: ImagePart) -> bool: ...
    def __iter__(self) -> ImagePart: ...
    def __len__(self) -> int: ...
    def append(self, item: ImagePart) -> None: ...
    def get_or_add_image_part(self, image_descriptor: ImageDescriptor) -> ImagePart: ...
    def _add_image_part(self, image: Image) -> ImagePart: ...
    def _get_by_sha1(self, sha1: str) -> ImagePart | None: ...
    def _next_image_partname(self, ext: str) -> PackURI: ...
